/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <engine>
#include <fun>
#include <hamsandwich>

#define PLUGIN "Energetic_drink"
#define VERSION "1.0"
#define AUTHOR "Gauss"

#define MAXSPEED 290.0
#define MAX_E 200
#define DURATION 40
#define RESPAWNTIME 60.0
#define MODEL_BURN "models/burn_energy.mdl"
#define MODEL_REDBULL "models/redbull_energy.mdl"
#define SPAWNSOUND "items/suitchargeok1.wav"
#define NAMECLASS "item_energetic"
#define TRAIL "sprites/zbeam3.spr"
#define SOUNDBURN "misc/we_burn.wav"
#define SOUNDREDBULL "misc/red_bull.wav"

new gszFile[128];
new burntime[33];
new redbulltime[33];
new trail;

const m_pPlayer	= 28
const LINUX_OFFSET_WEAPONS = 4
const m_flNextPrimaryAttack = 35
const m_flNextSecondaryAttack = 36

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_clcmd( "say /energetic", "CmdCreateEnergetic" );
	register_menucmd( register_menuid("EnergeticMenu"), 1023, "handleEnergeticMenu" );
	register_touch(NAMECLASS, "player","touching")
	register_event("DeathMsg","deathid","a")
	RegisterHam(Ham_Spawn,"player","ham_spawn",1)
	RegisterHam(Ham_Weapon_PrimaryAttack	, "weapon_9mmAR", "mp5_PrimaryAttack_Post", 1)
	RegisterHam(Ham_Weapon_SecondaryAttack	, "weapon_9mmAR", "mp5_SecondaryAttack_Post", 1)
}

public plugin_cfg()
{
	new szDir[64];
	new szMap[32];
	get_basedir(szDir, 64);
	add(szDir, 64, "/energetic_drink");
	if (!dir_exists(szDir))
	{
		mkdir(szDir);
	}
	get_mapname(szMap, 32);
	formatex(gszFile, 96, "%s/%s.ed", szDir, szMap);
	server_cmd("sv_maxspeed %f",MAXSPEED)
	LoadED(0);
}

public plugin_precache()
{
	precache_model(MODEL_BURN)
	precache_model(MODEL_REDBULL)	
	precache_sound(SPAWNSOUND)
	precache_sound(SOUNDBURN)
	precache_sound(SOUNDREDBULL)
	trail = precache_model(TRAIL)
}

public CmdCreateEnergetic( id )
{
	ShowEnergeticMenu( id );
	return PLUGIN_HANDLED;
}

public ShowEnergeticMenu(id)
{
	if(!access(id,ADMIN_LEVEL_G)){client_print(id,print_chat,"У вас нет доступа к меню энергетиков (level G)");return 0;}
	
	new menu[1024],keys,len
	len = format(menu,sizeof(menu),"Energetic Drink Menu:^n^n");
	len += format(menu[len],sizeof(menu)-len,"1. Create Burn drink^n")
	len += format(menu[len],sizeof(menu)-len,"2. Create Red Bull drink^n")
	len += format(menu[len],sizeof(menu)-len,"3. Delete entity^n^n")
	len += format(menu[len],sizeof(menu)-len,"4. Save to file^n")
	len += format(menu[len],sizeof(menu)-len,"5. Load from file^n^n")
	len += format(menu[len],sizeof(menu)-len,"0. Exit^n")
	
	keys = ( 1<<0 | 1<<1 | 1<<2 | 1<<3 | 1<<4 | 1<<9 );
	
	show_menu(id,keys,menu,-1,"EnergeticMenu")
	
	return PLUGIN_HANDLED;
}

public handleEnergeticMenu( id, key )
{
	switch(key + 1)
	{
		case 1:
		{
			CreateAimingEnergetic( id,"B" );
			ShowEnergeticMenu( id );
		}
		case 2:
		{
			CreateAimingEnergetic( id,"R" );
			ShowEnergeticMenu( id );
		}
		case 3:
		{
			DeleteEnergetic(id);
			ShowEnergeticMenu( id );
		}
		case 4:
		{
			SaveED(id);
			ShowEnergeticMenu(id);
		}
		case 5:
		{
			LoadED(id);
			ShowEnergeticMenu(id);
		}
		case 10:
		{
			return 0;
		}
	}
	return PLUGIN_HANDLED;
}

public CreateAimingEnergetic(id,type[2])
{
	new origin[ 3 ], Float:vOrigin[ 3 ];
	get_user_origin( id, origin, 3 );
	IVecFVec( origin, vOrigin );
	vOrigin[2] = floatadd(vOrigin[2],10.0)
	CreateEnergetic(vOrigin,type,0);
}

public CreateEnergetic(Float:vOrigin[3],type[2],sound)
{
	new iEntity = create_entity( "info_target" );
	if( is_valid_ent( iEntity ) )
	{
		entity_set_string( iEntity, EV_SZ_classname, NAMECLASS );
		switch(type[0])
		{
			case 'B': entity_set_model(iEntity,MODEL_BURN);
				case 'R': entity_set_model(iEntity,MODEL_REDBULL);
			}
		entity_set_int( iEntity, EV_INT_solid,SOLID_TRIGGER);
		entity_set_int( iEntity, EV_INT_movetype, MOVETYPE_TOSS);
		new vSizeMin[3],vSizeMax[3];
		vSizeMin = {-5.0,-5.0,-10.0}; 
		vSizeMax = {5.0,5.0,10.0}; 
		entity_set_size( iEntity, vSizeMin, vSizeMax );
		new vAngles[3];
		pev(iEntity,pev_angles,vAngles)
		vAngles[0]=floatadd(vAngles[0],90.0)
		set_pev(iEntity,pev_angles,vAngles)
		entity_set_origin( iEntity, vOrigin );
		if(sound) emit_sound(iEntity,CHAN_ITEM,SPAWNSOUND,0.6,1.0,0,170)
		set_rendering( iEntity, kRenderFxGlowShell, random(200), random(200), random(200), kRenderNormal,5)
		return iEntity;
	}
	return 0;
}

public DeleteEnergetic(id)
{
	new al = get_aiming(id);
	
	if (al)
	{
		set_pev(al, pev_flags, FL_KILLME)
	}
	else
	{
		client_print(id,print_chat,"Не найдено энергетиков")
	}
}

public get_aiming(id)
{
	new origin[3];
	new Float:vOrigin[3];
	get_user_origin(id, origin, 3);
	IVecFVec(origin, vOrigin);
	new ent = -1;
	while ((ent = find_ent_in_sphere(ent, vOrigin, 5.0)))
	{
		if (isVALID(ent))
		{
			return ent;
		}
	}
	return 0;
}

public bool:isVALID(ent)
{
	if (is_valid_ent(ent))
	{
		new szClassname[32];
		entity_get_string(ent, EV_SZ_classname, szClassname, 32);
		if (equal(szClassname, NAMECLASS))
		{
			return true;
		}
	}
	return 0;
}

public touching(ent,id)
{
	new Float:vOrigin[3]
	new model[32]
	new type[2]
	new arg[4]
	new arg2[1]
	entity_get_vector(ent,EV_VEC_origin,vOrigin)
	entity_get_string(ent,EV_SZ_model,model,31)
	
	if (equal(model,MODEL_BURN))type[0]='B'
	if (equal(model,MODEL_REDBULL))type[0]='R'
	arg[0]=vOrigin[0]
	arg[1]=vOrigin[1]
	arg[2]=vOrigin[2]
	arg[3]=type[0]
	arg2[0]=id
	if(!pev(ent,pev_iuser1))
	{
		set_task(RESPAWNTIME,"RespawnEnergetic",0,arg,31,"a",1)
		if(type[0]=='B')
		{
			burntime[id]=DURATION
			emit_sound(id,CHAN_ITEM,SOUNDBURN,1.0,1.0,0,100)
			set_task(0.0,"BurnWork",0,arg2,31,"a",1);
		}
		if(type[0]=='R')
		{
			redbulltime[id]=DURATION
			emit_sound(id,CHAN_ITEM,SOUNDREDBULL,1.0,1.0,0,100)
			set_task(0.0,"RedBullWork",0,arg2,31,"a",1);
		}
	}
	set_pev(ent,pev_iuser1,1)
	set_pev(ent,pev_flags,FL_KILLME)
}

public BurnWork(arg[])
{
	new id=arg[0]
	
	if((is_user_connected(id))&&(is_user_alive(id)))
	{
		if(0<burntime[id]<=DURATION)
		{
			burntime[id]--
			server_cmd("sv_maxspeed 550")
			for(new i=1;i<get_maxplayers();i++)
			{
				if((is_user_connected(i))&&(is_user_alive(i)))
				{
					if(DURATION>=burntime[i]>0)
					{
						set_user_maxspeed(i,550.0)
						trail_user(i,255,0,0,1)
					}
					else
					{
						set_user_maxspeed(i,MAXSPEED)
					}
				}
			}
			new armor = get_user_armor(id)
			if(armor<=(MAX_E-2)) set_user_armor(id,armor + 2)
			set_hudmessage(255,0,0,-1.0,0.6,1,1.0,1.0,0.1,0.1,-1)
			show_hudmessage(id,"BURN : %d..",burntime[id])
			set_task(1.0,"BurnWork",0,arg,31,"a",1);
			
		}
		else 
		{
			client_print(id,print_chat,"Действие Burn закончилось")
			burntime[id]=0
			set_user_gravity(id,1.0)
			//server_cmd("sv_maxspeed %f",MAXSPEED)
			set_user_maxspeed(id,MAXSPEED)
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_HANDLED
}
public RedBullWork(arg[])
{
	new id=arg[0]
	
	if((is_user_connected(id))&&(is_user_alive(id)))
	{
		if(0<redbulltime[id]<=DURATION)
		{
			redbulltime[id]--
			server_cmd("sv_maxspeed 550")
			for(new i=1;i<get_maxplayers();i++)
			{
				if((is_user_connected(i))&&(is_user_alive(i)))
				{
					if(DURATION>=redbulltime[i]>0)
					{
						if(!burntime[i])set_user_maxspeed(i,400.0)
						set_user_gravity(i,0.4)
						trail_user(i,0,0,255,1)
					}
					else
					{
						set_user_maxspeed(i,MAXSPEED)
					}
				}
			}
			new health = get_user_health(id)
			if(health<=(MAX_E-2)) set_user_health(id,health + 2)
			set_hudmessage(0,0,255,-1.0,0.65,1,1.0,1.0,0.1,0.1,-1)
			show_hudmessage(id,"RED BULL : %d..",redbulltime[id])
			set_task(1.0,"RedBullWork",0,arg,31,"a",1);
			
		}
		else 
		{
			client_print(id,print_chat,"Действие Red Bull закончилось")
			redbulltime[id]=0
			set_user_gravity(id,1.0)
			//server_cmd("sv_maxspeed %f",MAXSPEED)
			set_user_maxspeed(id,MAXSPEED)
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_HANDLED
}
public trail_user(id,r,g,b,on)
{
	new dur;
	if (on){dur=10;} else {dur=0;}
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_BEAMFOLLOW)  
	write_short(id)
	write_short(trail)
	write_byte(dur)
	write_byte(8)
	write_byte(r)
	write_byte(g)
	write_byte(b)
	write_byte(255)
	message_end()
	
}
public deathid()
{
	new iVictim = read_data(2)
	burntime[iVictim]=0
	redbulltime[iVictim]=0
	set_user_maxspeed(iVictim,MAXSPEED)
	set_user_gravity(iVictim,1.0)
}

public ham_spawn(id)
{
	burntime[id]=0
	redbulltime[id]=0
	new arg[1]
	arg[0]=id
	set_task(0.1,"resetm",0,arg,31,"a",1)
	
}
public resetm(arg[])
{
	new id=arg[0]
	set_user_maxspeed(id,MAXSPEED)
	set_user_gravity(id,1.0)
}
public client_disconnect(id)
{
	burntime[id]=0
	redbulltime[id]=0
}
public RespawnEnergetic(arg[])
{
	new Float:vOrigin[3]
	new type[2]
	vOrigin[0]=arg[0]
	vOrigin[1]=arg[1]
	vOrigin[2]=arg[2]
	type[0]=arg[3]
	CreateEnergetic(vOrigin,type,1)
}

public SaveED(id)
{
	if(!access(id,ADMIN_LEVEL_G)){client_print(id,print_chat,"У вас нет доступа к меню энергетиков (level G)");return 0;}
	
	new ent = -1;
	new Float:vOrigin[3];
	new Count = 0;
	new szData[128];
	new model[32];
	new type[2];
	
	//open file for writing
	new file = fopen(gszFile, "wt");
	
	while ((ent = find_ent_by_class(ent, NAMECLASS)))
	{
		//get info
		entity_get_vector(ent, EV_VEC_origin, vOrigin);
		entity_get_string(ent,EV_SZ_model,model,31)
		if(equal(model,MODEL_BURN))type[0] = 'B';
		if(equal(model,MODEL_REDBULL))type[0] = 'R';
		
		//format info and save it to file
		formatex(szData, 128, "%c %f %f %f^n", type[0], vOrigin[0], vOrigin[1], vOrigin[2]);
		fputs(file, szData);
		
		//increment count
		++Count;
	}
	//get players name
	new szName[32];
	get_user_name(id, szName, 32);
	
	//notify all admins that the player saved to file
	for (new i = 1; i <= 32; ++i)
	{
		//make sure player is connected
		if (is_user_connected(i))
		{
			if (access(i,ADMIN_LEVEL_G))
			{
				client_print(i, print_chat, "%s сохранил %d энергетиков в файл!", szName, Count);
			}
		}
	}
	
	//close file
	fclose(file);
	return true;
}

public LoadED(id)
{
	if (file_exists(gszFile))
	{
		new szData[128];
		new ent;
		new oX[13], oY[13], oZ[13];
		new type[2]
		new Float:vOrigin[3];
		new Count = 0;
		//delete all
		while ((ent = find_ent_by_class(ent, NAMECLASS)))
		{
			set_pev(ent, pev_flags, FL_KILLME)
		}
		
		//open the file for reading
		new file = fopen(gszFile, "rt");
		
		//iterate through all the lines in the file
		while (!feof(file))
		{
			fgets(file, szData, 128);
			if(equal(szData,""))continue;
			parse(szData, type, 2, oX, 12, oY, 12, oZ, 12);
			
			vOrigin[0] = str_to_float(oX);
			vOrigin[1] = str_to_float(oY);
			vOrigin[2] = str_to_float(oZ);
			vOrigin[2] = floatadd(vOrigin[2],10.0)
			
			CreateEnergetic(vOrigin,type,0)			
			++Count;
		}
		
		
		//close the file
		fclose(file);
		
		//if a player is loading
		if (id > 0 && id <= 32)
		{
			//get players name
			new szName[32];
			get_user_name(id, szName, 32);
			
			//notify all admins that the player loaded
			for (new i = 1; i <= 32; ++i)
			{
				//make sure player is connected
				if (is_user_connected(i))
				{
					if (access(i,ADMIN_LEVEL_G))
					{
						client_print(i, print_chat, "%s загрузил %d энергетиков из файла!",  szName, Count);
					}
				}
			}
		}
	}
}


public mp5_PrimaryAttack_Post (const mp5)
{
	new player = get_pdata_cbase(mp5, m_pPlayer, LINUX_OFFSET_WEAPONS)
	if(DURATION>=burntime[player]>0)
	{
		set_pdata_float(mp5, m_flNextPrimaryAttack  , 0.05, LINUX_OFFSET_WEAPONS)
		set_pdata_float(mp5, m_flNextSecondaryAttack, 0.2, LINUX_OFFSET_WEAPONS)
	}
	else
	{
		set_pdata_float(mp5, m_flNextPrimaryAttack  , 0.1, LINUX_OFFSET_WEAPONS)
		set_pdata_float(mp5, m_flNextSecondaryAttack, 0.1, LINUX_OFFSET_WEAPONS)
	}
}


public mp5_SecondaryAttack_Post (const mp5)
{
	new player = get_pdata_cbase(mp5, m_pPlayer, LINUX_OFFSET_WEAPONS)
	if(DURATION>=burntime[player]>0)
	{
		set_pdata_float(mp5, m_flNextPrimaryAttack  , 0.1, LINUX_OFFSET_WEAPONS)
		set_pdata_float(mp5, m_flNextSecondaryAttack, 0.2, LINUX_OFFSET_WEAPONS)
	}
	else
	{
		set_pdata_float(mp5, m_flNextPrimaryAttack  , 0.8, LINUX_OFFSET_WEAPONS)
		set_pdata_float(mp5, m_flNextSecondaryAttack, 0.8, LINUX_OFFSET_WEAPONS)
	}
}
